// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/Goalpost.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/goalpost__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
#include "rosidl_runtime_c/string_functions.h"
// Member `top`
#include "rcss3d_agent_msgs/msg/detail/spherical__functions.h"

bool
rcss3d_agent_msgs__msg__Goalpost__init(rcss3d_agent_msgs__msg__Goalpost * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    rcss3d_agent_msgs__msg__Goalpost__fini(msg);
    return false;
  }
  // top
  if (!rcss3d_agent_msgs__msg__Spherical__init(&msg->top)) {
    rcss3d_agent_msgs__msg__Goalpost__fini(msg);
    return false;
  }
  return true;
}

void
rcss3d_agent_msgs__msg__Goalpost__fini(rcss3d_agent_msgs__msg__Goalpost * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // top
  rcss3d_agent_msgs__msg__Spherical__fini(&msg->top);
}

bool
rcss3d_agent_msgs__msg__Goalpost__are_equal(const rcss3d_agent_msgs__msg__Goalpost * lhs, const rcss3d_agent_msgs__msg__Goalpost * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // top
  if (!rcss3d_agent_msgs__msg__Spherical__are_equal(
      &(lhs->top), &(rhs->top)))
  {
    return false;
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Goalpost__copy(
  const rcss3d_agent_msgs__msg__Goalpost * input,
  rcss3d_agent_msgs__msg__Goalpost * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // top
  if (!rcss3d_agent_msgs__msg__Spherical__copy(
      &(input->top), &(output->top)))
  {
    return false;
  }
  return true;
}

rcss3d_agent_msgs__msg__Goalpost *
rcss3d_agent_msgs__msg__Goalpost__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Goalpost * msg = (rcss3d_agent_msgs__msg__Goalpost *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Goalpost), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__Goalpost));
  bool success = rcss3d_agent_msgs__msg__Goalpost__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__Goalpost__destroy(rcss3d_agent_msgs__msg__Goalpost * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcss3d_agent_msgs__msg__Goalpost__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcss3d_agent_msgs__msg__Goalpost__Sequence__init(rcss3d_agent_msgs__msg__Goalpost__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Goalpost * data = NULL;

  if (size) {
    data = (rcss3d_agent_msgs__msg__Goalpost *)allocator.zero_allocate(size, sizeof(rcss3d_agent_msgs__msg__Goalpost), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__Goalpost__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__Goalpost__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__Goalpost__Sequence__fini(rcss3d_agent_msgs__msg__Goalpost__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__Goalpost__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__Goalpost__Sequence *
rcss3d_agent_msgs__msg__Goalpost__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Goalpost__Sequence * array = (rcss3d_agent_msgs__msg__Goalpost__Sequence *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Goalpost__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__Goalpost__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__Goalpost__Sequence__destroy(rcss3d_agent_msgs__msg__Goalpost__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcss3d_agent_msgs__msg__Goalpost__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rcss3d_agent_msgs__msg__Goalpost__Sequence__are_equal(const rcss3d_agent_msgs__msg__Goalpost__Sequence * lhs, const rcss3d_agent_msgs__msg__Goalpost__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Goalpost__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Goalpost__Sequence__copy(
  const rcss3d_agent_msgs__msg__Goalpost__Sequence * input,
  rcss3d_agent_msgs__msg__Goalpost__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcss3d_agent_msgs__msg__Goalpost);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rcss3d_agent_msgs__msg__Goalpost * data =
      (rcss3d_agent_msgs__msg__Goalpost *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcss3d_agent_msgs__msg__Goalpost__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rcss3d_agent_msgs__msg__Goalpost__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Goalpost__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
