// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rcss3d_agent_msgs:msg/Spherical.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__SPHERICAL__STRUCT_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__SPHERICAL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rcss3d_agent_msgs__msg__Spherical __attribute__((deprecated))
#else
# define DEPRECATED__rcss3d_agent_msgs__msg__Spherical __declspec(deprecated)
#endif

namespace rcss3d_agent_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Spherical_
{
  using Type = Spherical_<ContainerAllocator>;

  explicit Spherical_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->r = 0.0f;
      this->phi = 0.0f;
      this->theta = 0.0f;
    }
  }

  explicit Spherical_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->r = 0.0f;
      this->phi = 0.0f;
      this->theta = 0.0f;
    }
  }

  // field types and members
  using _r_type =
    float;
  _r_type r;
  using _phi_type =
    float;
  _phi_type phi;
  using _theta_type =
    float;
  _theta_type theta;

  // setters for named parameter idiom
  Type & set__r(
    const float & _arg)
  {
    this->r = _arg;
    return *this;
  }
  Type & set__phi(
    const float & _arg)
  {
    this->phi = _arg;
    return *this;
  }
  Type & set__theta(
    const float & _arg)
  {
    this->theta = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator> *;
  using ConstRawPtr =
    const rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Spherical
    std::shared_ptr<rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Spherical
    std::shared_ptr<rcss3d_agent_msgs::msg::Spherical_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Spherical_ & other) const
  {
    if (this->r != other.r) {
      return false;
    }
    if (this->phi != other.phi) {
      return false;
    }
    if (this->theta != other.theta) {
      return false;
    }
    return true;
  }
  bool operator!=(const Spherical_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Spherical_

// alias to use template instance with default allocator
using Spherical =
  rcss3d_agent_msgs::msg::Spherical_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rcss3d_agent_msgs

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__SPHERICAL__STRUCT_HPP_
