// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rcss3d_agent_msgs:msg/Effector.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__TRAITS_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rcss3d_agent_msgs/msg/detail/effector__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'hinge_joint_vels'
#include "rcss3d_agent_msgs/msg/detail/hinge_joint_vel__traits.hpp"
// Member 'universal_joint_vels'
#include "rcss3d_agent_msgs/msg/detail/universal_joint_vel__traits.hpp"
// Member 'beams'
#include "rcss3d_agent_msgs/msg/detail/beam__traits.hpp"
// Member 'says'
#include "rcss3d_agent_msgs/msg/detail/say__traits.hpp"

namespace rcss3d_agent_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Effector & msg,
  std::ostream & out)
{
  out << "{";
  // member: hinge_joint_vels
  {
    if (msg.hinge_joint_vels.size() == 0) {
      out << "hinge_joint_vels: []";
    } else {
      out << "hinge_joint_vels: [";
      size_t pending_items = msg.hinge_joint_vels.size();
      for (auto item : msg.hinge_joint_vels) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: universal_joint_vels
  {
    if (msg.universal_joint_vels.size() == 0) {
      out << "universal_joint_vels: []";
    } else {
      out << "universal_joint_vels: [";
      size_t pending_items = msg.universal_joint_vels.size();
      for (auto item : msg.universal_joint_vels) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: beams
  {
    if (msg.beams.size() == 0) {
      out << "beams: []";
    } else {
      out << "beams: [";
      size_t pending_items = msg.beams.size();
      for (auto item : msg.beams) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: says
  {
    if (msg.says.size() == 0) {
      out << "says: []";
    } else {
      out << "says: [";
      size_t pending_items = msg.says.size();
      for (auto item : msg.says) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Effector & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: hinge_joint_vels
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.hinge_joint_vels.size() == 0) {
      out << "hinge_joint_vels: []\n";
    } else {
      out << "hinge_joint_vels:\n";
      for (auto item : msg.hinge_joint_vels) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: universal_joint_vels
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.universal_joint_vels.size() == 0) {
      out << "universal_joint_vels: []\n";
    } else {
      out << "universal_joint_vels:\n";
      for (auto item : msg.universal_joint_vels) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: beams
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.beams.size() == 0) {
      out << "beams: []\n";
    } else {
      out << "beams:\n";
      for (auto item : msg.beams) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: says
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.says.size() == 0) {
      out << "says: []\n";
    } else {
      out << "says:\n";
      for (auto item : msg.says) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Effector & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rcss3d_agent_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rcss3d_agent_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rcss3d_agent_msgs::msg::Effector & msg,
  std::ostream & out, size_t indentation = 0)
{
  rcss3d_agent_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rcss3d_agent_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rcss3d_agent_msgs::msg::Effector & msg)
{
  return rcss3d_agent_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rcss3d_agent_msgs::msg::Effector>()
{
  return "rcss3d_agent_msgs::msg::Effector";
}

template<>
inline const char * name<rcss3d_agent_msgs::msg::Effector>()
{
  return "rcss3d_agent_msgs/msg/Effector";
}

template<>
struct has_fixed_size<rcss3d_agent_msgs::msg::Effector>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rcss3d_agent_msgs::msg::Effector>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rcss3d_agent_msgs::msg::Effector>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__TRAITS_HPP_
